<?php

/*
* This file dynamically generates the svg used to represent the cross in the cookie notice.
*/

/**
 * Sanitization. Note that the WordPress core should not be loaded for performance reasons and a copy of the original
 * sanitize_hex_color() function available in the core has been added at the end of the file.
 */
$color = sanitize_hex_color($_GET['color']);

//set the content type as a image/svg+xml
header( 'Content-type: image/svg+xml' );

$output = '<?xml version="1.0" encoding="utf-8"?>
<svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
	 viewBox="0 0 20 20" style="enable-background:new 0 0 20 20;" xml:space="preserve">
<style type="text/css">
	.st0{display:none;}
	.st1{fill:' . htmlspecialchars($color, ENT_QUOTES) . ';}
</style>
<g>
	<polygon class="st1" points="15.3,6.8 13.2,4.7 10,7.9 6.8,4.7 4.7,6.8 7.9,10 4.7,13.2 6.8,15.3 10,12.1 13.2,15.3 15.3,13.2 
		12.1,10 	"/>
</g>
</svg>';

echo $output;

/**
 * Sanitize HEX color
 *
 * @param  string $color setting input.
 * @return string        setting input value.
 */
function sanitize_hex_color( $color ) {

	if ( '' === $color ) {
		return '';
	}

	// 3 or 6 hex digits, or the empty string.
	if ( preg_match( '|^#([A-Fa-f0-9]{3}){1,2}$|', $color ) ) {
		return $color;
	}

	return '';
}